<?php
/* Autor...:  */
/* Esquema.: FCO_CajaUsuario.xml */
/* Generado: 2021-10-20 01:20:13 */

/* Metodos de acceso a los campos de la tabla FCO_CajaUsuario */
abstract class BaseFCO_CajaUsuarioBN
{
    /* Campos de la tabla */
    private $i_IdCaja;    // IdCaja: ( no definido )
    private $s_IdUsuario;    // IdUsuario: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_EnUsoFlag;    // EnUsoFlag: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdCaja */
    public function setIdCaja( $i_IdCaja )
    {
        $this->i_IdCaja = $i_IdCaja;
    }

    /* Obtiene el valor del campo IdCaja */
    public function getIdCaja()
    {
        return $this->i_IdCaja;
    }

    /* Establece el valor del campo IdUsuario */
    public function setIdUsuario( $s_IdUsuario )
    {
        $this->s_IdUsuario = $s_IdUsuario;
    }

    /* Obtiene el valor del campo IdUsuario */
    public function getIdUsuario()
    {
        return $this->s_IdUsuario;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo EnUsoFlag */
    public function setEnUsoFlag( $i_EnUsoFlag )
    {
        $this->i_EnUsoFlag = $i_EnUsoFlag;
    }

    /* Obtiene el valor del campo EnUsoFlag */
    public function getEnUsoFlag()
    {
        return $this->i_EnUsoFlag;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCaja' => $this->getIdCaja(),
            'IdUsuario' => $this->getIdUsuario(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'EnUsoFlag' => $this->getEnUsoFlag(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto FCO_CajaUsuarioBN desde un RecordSet */
    public static function retrieveByRs( $o_FCO_CajaUsuarioRs )
    {
        $o_FCO_CajaUsuarioBN = new FCO_CajaUsuarioBN();
        $o_FCO_CajaUsuarioBN->setIdCaja( ( integer ) $o_FCO_CajaUsuarioRs[ "IdCaja" ] );
        $o_FCO_CajaUsuarioBN->setIdUsuario( $o_FCO_CajaUsuarioRs[ "IdUsuario" ] );
        $o_FCO_CajaUsuarioBN->setIdCompania( ( integer ) $o_FCO_CajaUsuarioRs[ "IdCompania" ] );
        $o_FCO_CajaUsuarioBN->setIdSucursal( ( integer ) $o_FCO_CajaUsuarioRs[ "IdSucursal" ] );
        $o_FCO_CajaUsuarioBN->setEnUsoFlag( ( integer ) $o_FCO_CajaUsuarioRs[ "EnUsoFlag" ] );
        $o_FCO_CajaUsuarioBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_FCO_CajaUsuarioRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_FCO_CajaUsuarioBN->setUsuarioCreacion( $o_FCO_CajaUsuarioRs[ "UsuarioCreacion" ] );
        $o_FCO_CajaUsuarioBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_FCO_CajaUsuarioRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_FCO_CajaUsuarioBN->setUsuarioModificacion( $o_FCO_CajaUsuarioRs[ "UsuarioModificacion" ] );
        return $o_FCO_CajaUsuarioBN;
    }
}
?>